require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&__ALPHA_MARVEL__H__)) {
    eval 'sub __ALPHA_MARVEL__H__ () {1;}' unless defined(&__ALPHA_MARVEL__H__);
    require 'linux/types.ph';
    require 'linux/pci.ph';
    require 'linux/spinlock.ph';
    require 'asm/compiler.ph';
    eval 'sub MARVEL_MAX_PIDS () {32;}' unless defined(&MARVEL_MAX_PIDS);
    eval 'sub MARVEL_IRQ_VEC_PE_SHIFT () {(10);}' unless defined(&MARVEL_IRQ_VEC_PE_SHIFT);
    eval 'sub MARVEL_IRQ_VEC_IRQ_MASK () {((1<<  &MARVEL_IRQ_VEC_PE_SHIFT) - 1);}' unless defined(&MARVEL_IRQ_VEC_IRQ_MASK);
    eval 'sub MARVEL_NR_IRQS () {(16+ ( &MARVEL_MAX_PIDS * (1<<  &MARVEL_IRQ_VEC_PE_SHIFT)));}' unless defined(&MARVEL_NR_IRQS);
    eval 'sub EV7_MASK40 {
        local($addr) = @_;
	    eval q((($addr) & ((1 << 41) - 1)));
    }' unless defined(&EV7_MASK40);
    eval 'sub EV7_KERN_ADDR {
        local($addr) = @_;
	    eval q((( &IDENT_ADDR |  &EV7_MASK40($addr))));
    }' unless defined(&EV7_KERN_ADDR);
    eval 'sub EV7_PE_MASK () {0x1ff;}' unless defined(&EV7_PE_MASK);
    eval 'sub EV7_IPE {
        local($pe) = @_;
	    eval q(((~(($pe)) &  &EV7_PE_MASK) << 35));
    }' unless defined(&EV7_IPE);
    eval 'sub EV7_CSR_PHYS {
        local($pe, $off) = @_;
	    eval q(( &EV7_IPE($pe) | (0x7ffc << 20) | ($off)));
    }' unless defined(&EV7_CSR_PHYS);
    eval 'sub EV7_CSRS_PHYS {
        local($pe) = @_;
	    eval q(( &EV7_CSR_PHYS($pe, 0)));
    }' unless defined(&EV7_CSRS_PHYS);
    eval 'sub EV7_CSR_KERN {
        local($pe, $off) = @_;
	    eval q(( &EV7_KERN_ADDR( &EV7_CSR_PHYS($pe, $off))));
    }' unless defined(&EV7_CSR_KERN);
    eval 'sub EV7_CSRS_KERN {
        local($pe) = @_;
	    eval q(( &EV7_KERN_ADDR( &EV7_CSRS_PHYS($pe))));
    }' unless defined(&EV7_CSRS_KERN);
    eval 'sub EV7_CSR_OFFSET {
        local($name) = @_;
	    eval q((( &NULL)-> ($name->{csr})));
    }' unless defined(&EV7_CSR_OFFSET);
    eval 'sub wbase_m_ena () {0x1;}' unless defined(&wbase_m_ena);
    eval 'sub wbase_m_sg () {0x2;}' unless defined(&wbase_m_sg);
    eval 'sub wbase_m_dac () {0x4;}' unless defined(&wbase_m_dac);
    eval 'sub wbase_m_addr () {0xfff00000;}' unless defined(&wbase_m_addr);
    eval 'sub IO7_KERN_ADDR {
        local($addr) = @_;
	    eval q(( &EV7_KERN_ADDR($addr)));
    }' unless defined(&IO7_KERN_ADDR);
    eval 'sub IO7_PORT_MASK () {0x7;}' unless defined(&IO7_PORT_MASK);
    eval 'sub IO7_IPE {
        local($pe) = @_;
	    eval q(( &EV7_IPE($pe)));
    }' unless defined(&IO7_IPE);
    eval 'sub IO7_IPORT {
        local($port) = @_;
	    eval q(((~(($port)) &  &IO7_PORT_MASK) << 32));
    }' unless defined(&IO7_IPORT);
    eval 'sub IO7_HOSE {
        local($pe, $port) = @_;
	    eval q(( &IO7_IPE($pe) |  &IO7_IPORT($port)));
    }' unless defined(&IO7_HOSE);
    eval 'sub IO7_MEM_PHYS {
        local($pe, $port) = @_;
	    eval q(( &IO7_HOSE($pe, $port) | 0x));
    }' unless defined(&IO7_MEM_PHYS);
    eval 'sub IO7_CONF_PHYS {
        local($pe, $port) = @_;
	    eval q(( &IO7_HOSE($pe, $port) | 0xfe000000));
    }' unless defined(&IO7_CONF_PHYS);
    eval 'sub IO7_IO_PHYS {
        local($pe, $port) = @_;
	    eval q(( &IO7_HOSE($pe, $port) | 0xff000000));
    }' unless defined(&IO7_IO_PHYS);
    eval 'sub IO7_CSR_PHYS {
        local($pe, $port, $off) = @_;
	    eval q(( &IO7_HOSE($pe, $port) | 0xff800000 | ($off)));
    }' unless defined(&IO7_CSR_PHYS);
    eval 'sub IO7_CSRS_PHYS {
        local($pe, $port) = @_;
	    eval q(( &IO7_CSR_PHYS($pe, $port, 0)));
    }' unless defined(&IO7_CSRS_PHYS);
    eval 'sub IO7_PORT7_CSRS_PHYS {
        local($pe) = @_;
	    eval q(( &IO7_CSR_PHYS($pe, 7, 0x300000)));
    }' unless defined(&IO7_PORT7_CSRS_PHYS);
    eval 'sub IO7_MEM_KERN {
        local($pe, $port) = @_;
	    eval q(( &IO7_KERN_ADDR( &IO7_MEM_PHYS($pe, $port))));
    }' unless defined(&IO7_MEM_KERN);
    eval 'sub IO7_CONF_KERN {
        local($pe, $port) = @_;
	    eval q(( &IO7_KERN_ADDR( &IO7_CONF_PHYS($pe, $port))));
    }' unless defined(&IO7_CONF_KERN);
    eval 'sub IO7_IO_KERN {
        local($pe, $port) = @_;
	    eval q(( &IO7_KERN_ADDR( &IO7_IO_PHYS($pe, $port))));
    }' unless defined(&IO7_IO_KERN);
    eval 'sub IO7_CSR_KERN {
        local($pe, $port, $off) = @_;
	    eval q(( &IO7_KERN_ADDR( &IO7_CSR_PHYS($pe,$port,$off))));
    }' unless defined(&IO7_CSR_KERN);
    eval 'sub IO7_CSRS_KERN {
        local($pe, $port) = @_;
	    eval q(( &IO7_KERN_ADDR( &IO7_CSRS_PHYS($pe, $port))));
    }' unless defined(&IO7_CSRS_KERN);
    eval 'sub IO7_PORT7_CSRS_KERN {
        local($pe) = @_;
	    eval q(( &IO7_KERN_ADDR( &IO7_PORT7_CSRS_PHYS($pe))));
    }' unless defined(&IO7_PORT7_CSRS_KERN);
    eval 'sub IO7_PLL_RNGA {
        local($pll) = @_;
	    eval q(((($pll) >> 3) & 0x7));
    }' unless defined(&IO7_PLL_RNGA);
    eval 'sub IO7_PLL_RNGB {
        local($pll) = @_;
	    eval q(((($pll) >> 6) & 0x7));
    }' unless defined(&IO7_PLL_RNGB);
    eval 'sub IO7_MEM_SPACE () {(2 * 1024* 1024* 1024);}' unless defined(&IO7_MEM_SPACE);
    eval 'sub IO7_IO_SPACE () {(8 * 1024* 1024);}' unless defined(&IO7_IO_SPACE);
    eval 'sub IO7_DAC_OFFSET () {(1 << 49);}' unless defined(&IO7_DAC_OFFSET);
    eval 'sub MARVEL_IACK_SC () {( ((( &IO7_CSRS_KERN(0, 0))-> &POx_IACK_SPECIAL)));}' unless defined(&MARVEL_IACK_SC);
    if(defined(&__KERNEL__)) {
	eval 'sub IO7_NUM_PORTS () {4;}' unless defined(&IO7_NUM_PORTS);
	eval 'sub IO7_AGP_PORT () {3;}' unless defined(&IO7_AGP_PORT);
	unless(defined(&__EXTERN_INLINE)) {
	    eval 'sub __EXTERN_INLINE () { &extern  &inline;}' unless defined(&__EXTERN_INLINE);
	    eval 'sub __IO_EXTERN_INLINE () {1;}' unless defined(&__IO_EXTERN_INLINE);
	}
	eval 'sub vucp () { &volatile \'unsigned char\' *;}' unless defined(&vucp);
	eval 'sub vusp () { &volatile \'unsigned short\' *;}' unless defined(&vusp);
	eval 'sub vuip () { &volatile \'unsigned int\' *;}' unless defined(&vuip);
	eval 'sub vulp () { &volatile \'unsigned long\' *;}' unless defined(&vulp);
	if(defined(&CONFIG_VGA_HOSE)) {
	    eval 'sub __marvel_is_port_vga {
	        local($a) = @_;
    		eval q(((($a) >= 0x3b0)  && (($a) < 0x3e0)  && (($a) != 0x3b3)  && (($a) != 0x3d3)));
	    }' unless defined(&__marvel_is_port_vga);
	    eval 'sub __marvel_is_mem_vga {
	        local($a) = @_;
    		eval q(((($a) >= 0xa0000)  && (($a) <= 0xc0000)));
	    }' unless defined(&__marvel_is_mem_vga);
	    eval 'sub FIXUP_IOADDR_VGA {
	        local($a) = @_;
    		eval q( &do {  &if ( &pci_vga_hose  &&  &__marvel_is_port_vga($a)) $a +=  ($pci_vga_hose->{io_space}->{start}); }  &while(0));
	    }' unless defined(&FIXUP_IOADDR_VGA);
	} else {
	    eval 'sub FIXUP_IOADDR_VGA {
	        local($a) = @_;
    		eval q();
	    }' unless defined(&FIXUP_IOADDR_VGA);
	}
	eval 'sub __marvel_is_port_kbd {
	    local($a) = @_;
    	    eval q(((($a) == 0x60) || (($a) == 0x64)));
	}' unless defined(&__marvel_is_port_kbd);
	eval 'sub __marvel_is_port_rtc {
	    local($a) = @_;
    	    eval q(((($a) == 0x70) || (($a) == 0x71)));
	}' unless defined(&__marvel_is_port_rtc);
	eval 'sub FIXUP_IOADDR_LEGACY {
	    local($a) = @_;
    	    eval q();
	}' unless defined(&FIXUP_IOADDR_LEGACY);
	eval 'sub FIXUP_IOADDR {
	    local($a) = @_;
    	    eval q( &do {  &FIXUP_IOADDR_VGA($a);  &FIXUP_IOADDR_LEGACY($a); }  &while(0));
	}' unless defined(&FIXUP_IOADDR);
	if(0) {
	    eval 'sub IOBUG {
	        local($x) = @_;
    		eval q( &printk $x);
	    }' unless defined(&IOBUG);
	    eval 'sub IOBUG_FILTER_IOADDR {
	        local($a, $x) = @_;
    		eval q( &if (! &__marvel_is_port_kbd($a)  && ! &__marvel_is_port_rtc($a))  &IOBUG($x));
	    }' unless defined(&IOBUG_FILTER_IOADDR);
	} else {
	    eval 'sub IOBUG {
	        local($x) = @_;
    		eval q();
	    }' unless defined(&IOBUG);
	    eval 'sub IOBUG_FILTER_IOADDR {
	        local($a, $x) = @_;
    		eval q();
	    }' unless defined(&IOBUG_FILTER_IOADDR);
	}
	eval 'sub __marvel_rtc_inb {
	    local($a) = @_;
    	    eval q( &__marvel_rtc_io(0, 0, ($a)));
	}' unless defined(&__marvel_rtc_inb);
	eval 'sub __marvel_rtc_outb {
	    local($b, $a) = @_;
    	    eval q( &__marvel_rtc_io(1, ($b), ($a)));
	}' unless defined(&__marvel_rtc_outb);
	undef(&FIXUP_IOADDR) if defined(&FIXUP_IOADDR);
	undef(&FIXUP_IOADDR_LEGACY) if defined(&FIXUP_IOADDR_LEGACY);
	undef(&FIXUP_IOADDR_VGA) if defined(&FIXUP_IOADDR_VGA);
	undef(&vucp) if defined(&vucp);
	undef(&vusp) if defined(&vusp);
	undef(&vuip) if defined(&vuip);
	undef(&vulp) if defined(&vulp);
	if(defined(&__WANT_IO_DEF)) {
	    eval 'sub __inb {
	        local($p) = @_;
    		eval q( &marvel_inb(($p)));
	    }' unless defined(&__inb);
	    eval 'sub __inw {
	        local($p) = @_;
    		eval q( &marvel_inw(($p)));
	    }' unless defined(&__inw);
	    eval 'sub __inl {
	        local($p) = @_;
    		eval q( &marvel_inl(($p)));
	    }' unless defined(&__inl);
	    eval 'sub __outb {
	        local($x,$p) = @_;
    		eval q( &marvel_outb(,($p)));
	    }' unless defined(&__outb);
	    eval 'sub __outw {
	        local($x,$p) = @_;
    		eval q( &marvel_outw(,($p)));
	    }' unless defined(&__outw);
	    eval 'sub __outl {
	        local($x,$p) = @_;
    		eval q( &marvel_outl(,($p)));
	    }' unless defined(&__outl);
	    eval 'sub __readb {
	        local($a) = @_;
    		eval q( &marvel_readb(($a)));
	    }' unless defined(&__readb);
	    eval 'sub __readw {
	        local($a) = @_;
    		eval q( &marvel_readw(($a)));
	    }' unless defined(&__readw);
	    eval 'sub __readl {
	        local($a) = @_;
    		eval q( &marvel_readl(($a)));
	    }' unless defined(&__readl);
	    eval 'sub __readq {
	        local($a) = @_;
    		eval q( &marvel_readq(($a)));
	    }' unless defined(&__readq);
	    eval 'sub __writeb {
	        local($x,$a) = @_;
    		eval q( &marvel_writeb(,($a)));
	    }' unless defined(&__writeb);
	    eval 'sub __writew {
	        local($x,$a) = @_;
    		eval q( &marvel_writew(,($a)));
	    }' unless defined(&__writew);
	    eval 'sub __writel {
	        local($x,$a) = @_;
    		eval q( &marvel_writel(,($a)));
	    }' unless defined(&__writel);
	    eval 'sub __writeq {
	        local($x,$a) = @_;
    		eval q( &marvel_writeq(,($a)));
	    }' unless defined(&__writeq);
	    eval 'sub __ioremap {
	        local($a,$s) = @_;
    		eval q( &marvel_ioremap(($a),($s)));
	    }' unless defined(&__ioremap);
	    eval 'sub __iounmap {
	        local($a) = @_;
    		eval q( &marvel_iounmap(($a)));
	    }' unless defined(&__iounmap);
	    eval 'sub __is_ioaddr {
	        local($a) = @_;
    		eval q( &marvel_is_ioaddr(($a)));
	    }' unless defined(&__is_ioaddr);
	    if(0) {
		eval 'sub __raw_readb {
		    local($a) = @_;
    		    eval q( &__readb($a));
		}' unless defined(&__raw_readb);
		eval 'sub __raw_readw {
		    local($a) = @_;
    		    eval q( &__readw($a));
		}' unless defined(&__raw_readw);
		eval 'sub __raw_readl {
		    local($a) = @_;
    		    eval q( &__readl($a));
		}' unless defined(&__raw_readl);
		eval 'sub __raw_readq {
		    local($a) = @_;
    		    eval q( &__readq($a));
		}' unless defined(&__raw_readq);
		eval 'sub __raw_writeb {
		    local($v,$a) = @_;
    		    eval q( &__writeb($v,$a));
		}' unless defined(&__raw_writeb);
		eval 'sub __raw_writew {
		    local($v,$a) = @_;
    		    eval q( &__writew($v,$a));
		}' unless defined(&__raw_writew);
		eval 'sub __raw_writel {
		    local($v,$a) = @_;
    		    eval q( &__writel($v,$a));
		}' unless defined(&__raw_writel);
		eval 'sub __raw_writeq {
		    local($v,$a) = @_;
    		    eval q( &__writeq($v,$a));
		}' unless defined(&__raw_writeq);
	    }
	}
	if(defined(&__IO_EXTERN_INLINE)) {
	    undef(&__EXTERN_INLINE) if defined(&__EXTERN_INLINE);
	    undef(&__IO_EXTERN_INLINE) if defined(&__IO_EXTERN_INLINE);
	}
    }
}
1;
